package interfaces;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import javax.swing.table.DefaultTableModel;
import util.bd.ConexaoBD;
import util.bd.Matriculas;

public class NovaMatricula extends javax.swing.JFrame {

    private Connection conexao;
    private String matricula;
    private String aluno;
    private String mAluno;
    private String disciplina;
    private int idTurma;

    public NovaMatricula(java.awt.Frame parent, boolean modal) {
        initComponents();
        this.setLocationRelativeTo(null);
        jBCadastrar.setEnabled(false);
        jCBDisciplina.removeAllItems();
        jCBDisciplina.addItem("Disciplinas");
        jCBDisciplina.setEnabled(false);
        jBTroca.setEnabled(false);


    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jBLocalizar = new javax.swing.JButton();
        jBCadastrar = new javax.swing.JButton();
        jBListar = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        jTFAluno = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jCBDisciplina = new javax.swing.JComboBox();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTableLista = new javax.swing.JTable();
        jFTMAtricula = new javax.swing.JFormattedTextField();
        jBTroca = new javax.swing.JButton();

        jLabel1.setText("Digite a matricula do aluno: (apenas numeros)");

        jBLocalizar.setText("Localizar");
        jBLocalizar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBLocalizarActionPerformed(evt);
            }
        });

        jBCadastrar.setText("Cadastrar");
        jBCadastrar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBCadastrarActionPerformed(evt);
            }
        });

        jBListar.setText("Listar");
        jBListar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBListarActionPerformed(evt);
            }
        });

        jLabel2.setText("Aluno:");

        jTFAluno.setEditable(false);
        jTFAluno.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTFAlunoActionPerformed(evt);
            }
        });

        jLabel3.setText("Selecione a disciplina:");

        jCBDisciplina.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        jCBDisciplina.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCBDisciplinaActionPerformed(evt);
            }
        });

        jTableLista.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null},
                {null, null},
                {null, null},
                {null, null}
            },
            new String [] {
                "Matricula", "Disciplina"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Integer.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane2.setViewportView(jTableLista);

        try {
            jFTMAtricula.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.MaskFormatter("##########")));
        } catch (java.text.ParseException ex) {
            ex.printStackTrace();
        }
        jFTMAtricula.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jFTMAtriculaActionPerformed(evt);
            }
        });

        jBTroca.setText("Trocar Aluno");
        jBTroca.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBTrocaActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 366, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jFTMAtricula, javax.swing.GroupLayout.DEFAULT_SIZE, 221, Short.MAX_VALUE)
                                    .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, 221, Short.MAX_VALUE))
                                .addGap(18, 18, 18))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel2)
                                .addGap(208, 208, 208))
                            .addComponent(jTFAluno, javax.swing.GroupLayout.DEFAULT_SIZE, 239, Short.MAX_VALUE)
                            .addComponent(jLabel3)
                            .addComponent(jCBDisciplina, 0, 239, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                            .addComponent(jBCadastrar, javax.swing.GroupLayout.DEFAULT_SIZE, 121, Short.MAX_VALUE)
                            .addComponent(jBLocalizar, javax.swing.GroupLayout.DEFAULT_SIZE, 121, Short.MAX_VALUE)
                            .addComponent(jBTroca, javax.swing.GroupLayout.DEFAULT_SIZE, 121, Short.MAX_VALUE)
                            .addComponent(jBListar, javax.swing.GroupLayout.DEFAULT_SIZE, 121, Short.MAX_VALUE))))
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jBCadastrar, jBListar, jBLocalizar});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jBLocalizar)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jBTroca)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jBCadastrar)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jBListar)
                            .addComponent(jCBDisciplina, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jFTMAtricula, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTFAluno, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(7, 7, 7)
                        .addComponent(jLabel3)))
                .addGap(18, 18, 18)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 194, Short.MAX_VALUE)
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {jBCadastrar, jBListar, jBLocalizar});

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jTFAlunoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTFAlunoActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTFAlunoActionPerformed

    private void jFTMAtriculaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jFTMAtriculaActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jFTMAtriculaActionPerformed

    private void jBLocalizarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBLocalizarActionPerformed
        conexao = new ConexaoBD().obterConexao();
        jFTMAtricula.setEnabled(false);
        jBTroca.setEnabled(true);
        this.matricula = jFTMAtricula.getText();
        System.out.println("matricula: " + this.matricula);
        String sql1 = "SELECT a.alID FROM aluno a WHERE a.alMatricula = ?";
        try {
            PreparedStatement st = conexao.prepareStatement(sql1);
            // preenchendo as ? na instrucao SQL
            st.setString(1, this.matricula);
            // executando
            ResultSet rs = st.executeQuery();
            rs.next();
            this.mAluno = rs.getString("alID");
            rs.close();
            st.close();
        } catch (SQLException ex) {
            System.err.println("Erro: " + ex.toString());
        }
        this.popularCB();
    }//GEN-LAST:event_jBLocalizarActionPerformed

    private void jBListarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBListarActionPerformed
        DefaultTableModel modelo = (DefaultTableModel) jTableLista.getModel();
        while (modelo.getRowCount() > 0) {
            modelo.removeRow(0);
        }
        ArrayList<Matriculas> al = this.listagemParaTabela();
        adicionarNaTabela(al);
    }

    private ArrayList<Matriculas> listagemParaTabela() {
        conexao = new ConexaoBD().obterConexao();
        ArrayList<Matriculas> lista = new ArrayList<Matriculas>();
        String sql = "select ma.maID, di.diNome from aluno al, disciplinas di, "
                + "turma tu,matriculas ma where al.alMatricula = ? and al.alID = ma.maAluno and "
                + "ma.maTurma = tu.tuID and tu.tuDisciplina = di.diID";
        try {
            PreparedStatement instrucao = conexao.prepareStatement(sql);
            // executando a instrução
            instrucao.setString(1, this.matricula);
            ResultSet rs = instrucao.executeQuery();
            // percorrendo a lista obtida do banco
            while (rs.next()) {
                Matriculas matricula = new Matriculas();
                matricula.setMatricula(rs.getInt("maID"));
                matricula.setDisciplina(rs.getString("diNome"));
                // adicionando no ArrayList
                lista.add(matricula);
            }
            // fechando
            instrucao.close();
        } catch (SQLException ex) {
            System.err.println("Erro na listagem de contatos: " + ex.toString());
        }
        return lista;
    }

    private void adicionarNaTabela(ArrayList<Matriculas> al) {
        DefaultTableModel modelo = (DefaultTableModel) jTableLista.getModel();
        // percorrendo a lista de contatos
        for (Matriculas matricula : al) {
            String vetor[] = new String[2];
            vetor[0] = Integer.toString(matricula.getMatricula());
            vetor[1] = matricula.getDisciplina();
            //adicionando na tabela
            modelo.addRow(vetor);
        }

    }//GEN-LAST:event_jBListarActionPerformed

    private void jBCadastrarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBCadastrarActionPerformed
        conexao = new ConexaoBD().obterConexao();
        this.disciplina = (String) jCBDisciplina.getSelectedItem();
        String sql1 = "select tu.tuID from turma tu, disciplinas di where tu.tuDisciplina = di.diID and di.diNome = ?";
        try {
            PreparedStatement st = conexao.prepareStatement(sql1);
            // preenchendo as ? na instrucao SQL
            st.setString(1, this.disciplina);
            System.err.println(sql1 + "..." + this.disciplina);
            // executando
            ResultSet rs = st.executeQuery();
            rs.next();
            this.idTurma = rs.getInt("tuID");
            System.out.println("" + this.idTurma);
            rs.close();
            st.close();
        } catch (SQLException ex) {
            System.err.println("Erro: " + ex.toString());
        }

        String sql2 = "INSERT INTO matriculas (maTurma, maAluno) VALUES (?,?)";
        try {
            PreparedStatement st = conexao.prepareStatement(sql2);
            // preenchendo as ? na instrucao SQL
            st.setInt(1, this.idTurma);
            st.setString(2, this.mAluno);
            // executando
            st.execute();
            st.close();
        } catch (SQLException ex) {
            System.err.println("Erro: " + ex.toString());
        }

        this.popularCB();
    }

    private void popularCB() {

        String sql = "SELECT al.alNome, d.* FROM disciplinas d, aluno al WHERE NOT d.diID IN (SELECT d.diID FROM turma t, disciplinas d, matriculas m, aluno al WHERE m.maAluno=? AND m.maTurma = t.tuID AND t.tuDisciplina = d.diID) AND al.alID=?";
        try {
            PreparedStatement st = conexao.prepareStatement(sql);
            // preenchendo as ? na instrucao SQL
            st.setString(1, this.mAluno);
            st.setString(2, this.mAluno);

            // executando
            ResultSet rs = st.executeQuery();
            jCBDisciplina.removeAllItems();
            while (rs.next() == true) {
                String disciplina1 = rs.getString("diNome");
                jCBDisciplina.addItem(disciplina1);
                aluno = rs.getString("alNome");
            }
            jTFAluno.setText(aluno);
            jCBDisciplina.setEnabled(true);
            jBCadastrar.setEnabled(true);
            jBLocalizar.setEnabled(false);
            // fechando a instrucao
            st.close();
            System.out.println("Localizado com sucesso");
        } catch (SQLException ex) {
            System.err.println("Erro ao inserir: " + ex.toString());
        }
        try {
            conexao.close();
        } catch (SQLException ex) {
            System.err.println("Erro ao encerrar conexão: " + ex.toString());
        }


    }//GEN-LAST:event_jBCadastrarActionPerformed

    private void jCBDisciplinaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCBDisciplinaActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jCBDisciplinaActionPerformed

    private void jBTrocaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBTrocaActionPerformed
        jBCadastrar.setEnabled(false);
        jCBDisciplina.removeAllItems();
        jCBDisciplina.addItem("Disciplinas");
        jFTMAtricula.setText("");
        jFTMAtricula.setEnabled(true);
        jBLocalizar.setEnabled(true);
        jCBDisciplina.setEnabled(false);
        jBTroca.setEnabled(false);
        DefaultTableModel tabela = (DefaultTableModel) jTableLista.getModel();
        tabela.setNumRows(0);
        jFTMAtricula.requestFocus();
    }//GEN-LAST:event_jBTrocaActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jBCadastrar;
    private javax.swing.JButton jBListar;
    private javax.swing.JButton jBLocalizar;
    private javax.swing.JButton jBTroca;
    private javax.swing.JComboBox jCBDisciplina;
    private javax.swing.JFormattedTextField jFTMAtricula;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTextField jTFAluno;
    private javax.swing.JTable jTableLista;
    // End of variables declaration//GEN-END:variables
}
