package interfaces;

import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.sql.Connection;
import java.sql.ResultSet;
import java.util.ArrayList;
import javax.swing.table.DefaultTableModel;
import util.bd.*;

public class CadastroDocentes extends javax.swing.JFrame {

    private Connection conexao;
    // private ArrayList<Docentes> al;

    public CadastroDocentes(java.awt.Frame parent, boolean modal) {
        initComponents();
        this.setLocationRelativeTo(parent);
        conexao = new ConexaoBD().obterConexao();
        jTFNome.setEnabled(false);
        jTFLogin.setEnabled(false);
        jTFSenha.setEnabled(false);


    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        Nome = new javax.swing.JLabel();
        jTFNome = new javax.swing.JTextField();
        jLLogin = new javax.swing.JLabel();
        jTFLogin = new javax.swing.JTextField();
        jLTel = new javax.swing.JLabel();
        jTFSenha = new javax.swing.JTextField();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTableLista = new javax.swing.JTable();
        jBAdicionar = new javax.swing.JButton();
        jBAlterar = new javax.swing.JButton();
        jBConcluido = new javax.swing.JButton();
        jBListar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        Nome.setText("Nome");

        jTFNome.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTFNomeActionPerformed(evt);
            }
        });

        jLLogin.setText("Login");

        jTFLogin.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTFLoginActionPerformed(evt);
            }
        });

        jLTel.setText("Senha");

        jTFSenha.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTFSenhaActionPerformed(evt);
            }
        });

        jTableLista.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "iD", "Nome", "Login", "Senha"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Long.class, java.lang.String.class, java.lang.String.class, java.lang.Long.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane1.setViewportView(jTableLista);

        jBAdicionar.setText("Adicionar");
        jBAdicionar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBAdicionarActionPerformed(evt);
            }
        });

        jBAlterar.setText("Alterar");

        jBConcluido.setText("Concluído");
        jBConcluido.setEnabled(false);
        jBConcluido.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBConcluidoActionPerformed(evt);
            }
        });

        jBListar.setText("Listar");
        jBListar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBListarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLLogin)
                            .addComponent(Nome)
                            .addComponent(jLTel))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jTFNome, javax.swing.GroupLayout.PREFERRED_SIZE, 201, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jTFSenha, javax.swing.GroupLayout.PREFERRED_SIZE, 201, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jTFLogin, javax.swing.GroupLayout.PREFERRED_SIZE, 201, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jBListar)
                            .addComponent(jBConcluido)
                            .addComponent(jBAlterar)
                            .addComponent(jBAdicionar)))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(25, Short.MAX_VALUE))
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jBAdicionar, jBAlterar, jBConcluido, jBListar});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(3, 3, 3)
                        .addComponent(jTFNome, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(Nome)
                        .addComponent(jBAdicionar)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addGroup(layout.createSequentialGroup()
                            .addGap(3, 3, 3)
                            .addComponent(jTFLogin, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addComponent(jLLogin))
                    .addComponent(jBConcluido))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE, false)
                    .addComponent(jLTel)
                    .addComponent(jTFSenha, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jBAlterar))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jBListar)
                .addGap(18, 18, 18)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 180, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(62, 62, 62))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    public void cadastroProfessor(String nome, String Login, int Senha) {

        String sql = "INSERT INTO professores (prNome,prLogin,prSenha) VALUES (?,?,?)";
        try {
            PreparedStatement st = conexao.prepareStatement(sql);
            // preenchendo as ? na instrucao SQL
            st.setString(1, nome);
            st.setString(2, Login);
            st.setInt(3, Senha);
            // executando
            st.execute();
            // fechando a instrucao
            st.close();
            System.out.println("Inserido com sucesso");
        } catch (SQLException ex) {
            System.err.println("Erro ao inserir: " + ex.toString());
        }
    }
    private void jTFNomeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTFNomeActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTFNomeActionPerformed

    private void jBConcluidoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBConcluidoActionPerformed
        // TODO add your handling code here:
        jBConcluido.setEnabled(false);
        jBAdicionar.setEnabled(true);
        String nome = jTFNome.getText();
        String login = jTFLogin.getText();
        int senha = Integer.parseInt(jTFSenha.getText());
        this.cadastroProfessor(nome, login, senha);
        jTFNome.setText("");
        jTFLogin.setText("");
        jTFSenha.setText("");
        jTFNome.setEnabled(false);
        jTFLogin.setEnabled(false);
        jTFSenha.setEnabled(false);

    }//GEN-LAST:event_jBConcluidoActionPerformed

    private void jBAdicionarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBAdicionarActionPerformed
        jBConcluido.setEnabled(true);
        jBAdicionar.setEnabled(false);
        jBAlterar.setEnabled(false);
        jTFNome.setText("");
        jTFLogin.setText("");
        jTFSenha.setText("");
        jTFNome.setEnabled(true);
        jTFLogin.setEnabled(true);
        jTFSenha.setEnabled(true);



    }//GEN-LAST:event_jBAdicionarActionPerformed

    public void adicionarNaTabela(ArrayList<Docentes> al) {
        DefaultTableModel modelo = (DefaultTableModel) jTableLista.getModel();
        // percorrendo a lista de contatos
        for (Docentes docentes : al) {
            String vetor[] = new String[4];
            vetor[0] = Long.toString(docentes.getId());
            vetor[1] = docentes.getNome();
            vetor[2] = docentes.getLogin();
            vetor[3] = Long.toString(docentes.getSenha());
            //adicionando na tabela
            modelo.addRow(vetor);
        }
    }

    public ArrayList<Docentes> listagemParaTabela() {
        ArrayList<Docentes> lista = new ArrayList<Docentes>();
        String sql = "SELECT * FROM professores";
        try {
            PreparedStatement instrucao = conexao.prepareStatement(sql);
            // executando a instrução
            ResultSet rs = instrucao.executeQuery();
            // percorrendo a lista obtida do banco

            while (rs.next()) {
                Docentes pessoa = new Docentes();
                pessoa.setId(new Long(rs.getInt("prID")));
                pessoa.setNome(rs.getString("prNome"));
                pessoa.setLogin(rs.getString("prLogin"));
                pessoa.setSenha(new Long(rs.getString("prSenha")));
                // adicionando no ArrayList
                lista.add(pessoa);
            }
            // fechando
            instrucao.close();
        } catch (SQLException ex) {
            System.err.println("Erro na listagem de contatos: " + ex.toString());
        }
        return lista;
    }

    private void jBListarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBListarActionPerformed
        DefaultTableModel modelo = (DefaultTableModel) jTableLista.getModel();
        while (modelo.getRowCount() > 0) {
            modelo.removeRow(0);
        }

        ArrayList<Docentes> al = this.listagemParaTabela();
        adicionarNaTabela(al);


    }//GEN-LAST:event_jBListarActionPerformed

    private void jTFSenhaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTFSenhaActionPerformed
        // TODO add your handling code here:
}//GEN-LAST:event_jTFSenhaActionPerformed

    private void jTFLoginActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTFLoginActionPerformed
        // TODO add your handling code here:
}//GEN-LAST:event_jTFLoginActionPerformed
    /**
     * @param args the command line arguments
     */
    /*public static void main(String args[]) {
    java.awt.EventQueue.invokeLater(new Runnable() {
    
    public void run() {
    CadastroDocentes dialog = new CadastroDocentes(new javax.swing.JFrame(), true);
    dialog.addWindowListener(new java.awt.event.WindowAdapter() {
    
    @Override
    public void windowClosing(java.awt.event.WindowEvent e) {
    System.exit(0);
    }
    });
    dialog.setVisible(true);
    
    }
    });
    }*/
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel Nome;
    private javax.swing.JButton jBAdicionar;
    private javax.swing.JButton jBAlterar;
    private javax.swing.JButton jBConcluido;
    private javax.swing.JButton jBListar;
    private javax.swing.JLabel jLLogin;
    private javax.swing.JLabel jLTel;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextField jTFLogin;
    private javax.swing.JTextField jTFNome;
    private javax.swing.JTextField jTFSenha;
    private javax.swing.JTable jTableLista;
    // End of variables declaration//GEN-END:variables
}
