package interfaces;

import java.sql.Connection;
import java.util.HashMap;
import net.sf.jasperreports.engine.JasperFillManager;
import net.sf.jasperreports.engine.JasperPrint;
import net.sf.jasperreports.view.JasperViewer;
import util.bd.ConexaoBD;

public class RelatoriosPr extends javax.swing.JFrame {

    private String caminho;

    public RelatoriosPr(java.awt.Frame parent, boolean modal) {
        initComponents();
        this.setLocationRelativeTo(parent);

    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jCBTipo = new javax.swing.JComboBox();
        jBGerar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jCBTipo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Selecione o tipo de relatório", "Alunos cadastrados", "Turmas" }));

        jBGerar.setText("Gerar");
        jBGerar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBGerarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(22, 22, 22)
                        .addComponent(jCBTipo, javax.swing.GroupLayout.PREFERRED_SIZE, 161, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(62, 62, 62)
                        .addComponent(jBGerar)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(38, 38, 38)
                .addComponent(jCBTipo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(37, 37, 37)
                .addComponent(jBGerar)
                .addContainerGap(49, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jBGerarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBGerarActionPerformed
        this.caminho = (String) jCBTipo.getSelectedItem();
        int tipo = jCBTipo.getSelectedIndex();
        switch (tipo) {
            case 1:
                this.caminho = "D:/CodigosFonte/POO/Relatorios_ProjetoFinal/relatorio_alunos_cadastrados.jasper";
                //this.caminho = "relatorios/relatorio_alunos_cadastrados.jasper";
                break;
            case 2:
                this.caminho = "D:/CodigosFonte/POO/Relatorios_ProjetoFinal/relatorio_turmas_cadastradas.jasper";
                // this.caminho = "relatorios/relatorio_turmas_cadastradas.jasper";
                break;
           /* case 3:
                this.caminho = "D:/CodigosFonte/POO/Relatorios_ProjetoFinal/relatorio_conceitos.jasper";
                // this.caminho = "relatorios/relatorio_conceitos.jasper";
                break;*/
        }
        Relatorio(this.caminho);
    }//GEN-LAST:event_jBGerarActionPerformed
    private Connection conexao;

    public JasperPrint gerar(String caminho) {
        JasperPrint rel = null;
        try {
            conexao = new ConexaoBD().obterConexao();
            HashMap map = new HashMap();
            String arquivoJasper = caminho;

            rel = JasperFillManager.fillReport(arquivoJasper, map, conexao);
        } catch (Exception e) {
            System.err.println("Erro: " + e.toString());
        }

        return rel;
    }

    public void Relatorio(String caminho) {
        this.caminho = caminho;
        JasperPrint relat = gerar(this.caminho);
        JasperViewer.viewReport(relat, false);
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jBGerar;
    private javax.swing.JComboBox jCBTipo;
    // End of variables declaration//GEN-END:variables
}
